- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Friends

# MColorArray Class Reference

# OpenMaya - API module for common classes

Search for all occurrences

## Detailed Description

Array of MColor data type.

This class implements an array of MColor's. Common convenience functions are available, and the implementation is compatible with the internal Maya implementation so that it can be passed efficiently between plugins and internal maya data structures.

Examples:

  cvColorShader.cpp, meshRemapCmd.cpp, meshRemapCmd.h, meshReorderCmd.cpp, meshReorderCmd.h, polyWriter.h, and volumeLightCmd.cpp.

`#include <MColorArray.h>`

List of all members.

## Public Member Functions
| MColorArray ()
| Default constructor.
| MColorArray (const MColorArray &other)
| Copy constructor.
| MColorArray (const MColor src[], unsigned int count)
| NO SCRIPT SUPPORT.
| MColorArray (const float src[][4], unsigned int count)
| Create a new array of MColor's and initialize it with the given elements.
| MColorArray (const double src[][4], unsigned int count)
| Create a new array of MColor's and initialize it with the given elements.
| MColorArray (unsigned int initialSize, const MColor &initialValue=MColor::kOpaqueBlack)
| Create a new array of MColor's of a specified size and initialize all the elements with the given initial value.
| ~MColorArray ()
| The class destructor.
const MColor & | operator[] (unsigned int index) const
| Index operator.
MColorArray & | operator= (const MColorArray &other)
| Assignment operator copies all of the elements of the other array into this one.
MStatus | set (const MColor &element, unsigned int index)
| Sets the value of the indicated element to the indicated value.
MStatus | set (unsigned int index, float r, float g, float b, float a=1)
| Sets the value of the indicated element to the indicated values.
MStatus | set (float val[4], unsigned int index)
| Sets the value of the indicated element to the indicated value.
MStatus | set (float elements[][4], unsigned int size)
| Resets the values of the color components.
MStatus | set (double elements[][4], unsigned int size)
| Resets the values of the color components.
MStatus | setLength (unsigned int length)
| Set the length of the array.
unsigned int | length () const
| Returns the number of elements in the instance.
MStatus | remove (unsigned int index)
| Remove the array element at the given index.
MStatus | insert (const MColor &element, unsigned int index)
| Inserts a new value into the array at the given index.
MStatus | append (const MColor &element)
| Adds a new element to the end of the array.
MStatus | append (float r, float g, float b, float a=1)
| Adds a new element to the end of the array.
MStatus | copy (const MColorArray &source)
| Copy the contents of the source array to this array.
MStatus | clear ()
| Clear the contents of the array.
MStatus | get (float dest[][4]) const
| Copy the elements of the array into the C++ array of float arrays.
void | setSizeIncrement (unsigned int newIncrement)
| Set the size by which the array will be expanded whenever expansion is necessary.
unsigned int | sizeIncrement () const
| Return the size by which the array will be expanded whenever expansion is necessary.
MColor & | operator[] (unsigned int index)
| NO SCRIPT SUPPORT.
## Static Public Member Functions
static const char * | className ()
| Returns the name of this class.
## Friends
OPENMAYA_EXPORT std::ostream & | operator<< (std::ostream &os, const MColorArray &array)
| NO SCRIPT SUPPORT.

## Constructor & Destructor Documentation

MColorArray | ( |  | ) |

Default constructor.

The instance is set to contain no elements.

MColorArray | ( | const MColorArray & | other | ) |

Copy constructor.

Parameters:

  [in] | other | the array with which to initialize this instance

MColorArray | ( | const MColor | src[],
|  | unsigned int | count
| ) |  |

NO SCRIPT SUPPORT.

Create a new array of MColor's and initialize it with the given elements.

Parameters:

  [in] | src | an array of MStrings
  [in] | count | the number of elements in the src array

MColorArray | ( | const float | src[][4],
|  | unsigned int | count
| ) |  |

Create a new array of MColor's and initialize it with the given elements.

Parameters:

  [in] | src | a C++ array of float arrays of length four
  [in] | count | the number of elements in the array

MColorArray | ( | const double | src[][4],
|  | unsigned int | count
| ) |  |

Create a new array of MColor's and initialize it with the given elements.

Parameters:

  [in] | src | a C++ array of double arrays of length four
  [in] | count | the number of elements in the array

MColorArray | ( | unsigned int | initialSize,
|  | const MColor & | initialValue = `MColor::kOpaqueBlack`
| ) |  |

Create a new array of MColor's of a specified size and initialize all the elements with the given initial value.

Parameters:

  [in] | initialSize | the initial size of the array
  [in] | initialValue | the initial value of each element

## Member Function Documentation

const MColor & operator[] | ( | unsigned int | index | ) | const

Index operator.

Returns the value of the element at the given index. No range checking is done - valid indices are 0 to length()-1.

Parameters:

  [in] | index | the index of the element whose value is to be returned

Returns:
  The value of the indicated element.

MColorArray & operator= | ( | const MColorArray & | other | ) |

Assignment operator copies all of the elements of the other array into this one.

If the other array was returned as a reference to internal data, then this array will also become a reference rather than doing a full copy.

Parameters:

  [in] | other | the array being copied

Returns:
  A reference to this array

MStatus set | ( | const MColor & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Sets the value of the indicated element to the indicated value.

Parameters:

  [in] | element | the new value for the indicated element
  [in] | index | the index of the element that is to be set to the the new value

Returns:
  MS::kSuccess if the value was set successfully and MS::kFailure otherwise

MStatus set | ( | unsigned int | index,
|  | float | r,
|  | float | g,
|  | float | b,
|  | float | a = `1`
| ) |  |

Search for all occurrences

Sets the value of the indicated element to the indicated values.

The r component of the element is set to r, the g component to g, the b component to b, and the a component to a.

Parameters:

  [in] | index | the index of the element that is to be set to the the new value
  [in] | r | the new value for the r component
  [in] | g | the new value for the g component
  [in] | b | the new value for the b component
  [in] | a | the new value for the a component,defaulted to 1

Returns:
  MS::kSuccess if the value was set successfully and MS::kFailure otherwise

MStatus set | ( | float | val[4],
|  | unsigned int | index
| ) |  |

Search for all occurrences

Sets the value of the indicated element to the indicated value.

The r component of the element is set to val[0], the g component to val[1], the b component to val[2], and the a component to val[3].

Parameters:

  [in] | val | the new value for the indicated element
  [in] | index | the index of the element that is to be set to the the new value

Returns:
  MS::kSuccess if the value was set successfully and MS::kFailure otherwise

MStatus set | ( | float | elements[][4],
|  | unsigned int | size
| ) |  |

Search for all occurrences

Resets the values of the color components.

The length of the passed in C++ array should be same as the length of the ColorArray to which we are setting the values.

Parameters:

  [in] | elements | C++ array of float arrays of length four.
  [in] | size | the number of elements in the array.

Returns:
  MS::kSuccess if the value was set successfully and MS::kFailure otherwise

MStatus set | ( | double | elements[][4],
|  | unsigned int | size
| ) |  |

Search for all occurrences

Resets the values of the color components.

The length of the passed in C++ array should be same as the length of the ColorArray to which we are setting the values.

Parameters:

  [in] | elements | C++ array of double arrays of length four.
  [in] | size | the number of elements in the array.

Returns:
  MS::kSuccess if the value was set successfully and MS::kFailure otherwise

MStatus setLength | ( | unsigned int | length | ) |

Search for all occurrences

Set the length of the array.

This will grow and shrink the array as desired. Elements that are grown have uninitialized values, while those which are shrunk will lose the data contained in the deleted elements (ie. it will release the memory).

Parameters:

  [in] | length | the new size of the array

Returns:
  MS::kSuccess if the length was set successfully and MS::kFailure otherwise

Examples:
  cvColorShader.cpp.

unsigned int length | ( |  | ) | const

Search for all occurrences

Returns the number of elements in the instance.

Returns:
  The number of elements in the instance

Examples:
  meshRemapCmd.cpp.

MStatus remove | ( | unsigned int | index | ) |

Search for all occurrences

Remove the array element at the given index.

All array elements following the removed element are shifted toward the first element.

Parameters:

  [in] | index | index of the element to be removed

Returns:
  MS::kSuccess if the remove was successful and MS::kFailure otherwise

MStatus insert | ( | const MColor & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Inserts a new value into the array at the given index.

The initial element at that index, and all following elements, are shifted towards the last. If the array cannot be expanded in size by 1 element, then the insert will fail and the existing array will remain unchanged.

Parameters:

  [in] | element | the new value to insert into the array
  [in] | index | the index of the element to set to the the new value

Returns:
  MS::kSuccess if the insert was successful and MS::kFailure otherwise

MStatus append | ( | const MColor & | element | ) |

Search for all occurrences

Adds a new element to the end of the array.

If the array cannot be expanded in size by 1 element, then the append will fail and the existing array will remain unchanged.

Parameters:

  [in] | element | the value for the new last element

Returns:
  MS::kSuccess if the append was successful and MS::kFailure otherwise

Examples:
  volumeLightCmd.cpp.

MStatus append | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | w = `1`
| ) |  |

Search for all occurrences

Adds a new element to the end of the array.

The appended element has the indicated values for its x,y,z and w components. The x component of the element is set to x, the y component to y, the z component to z, and the w component to w.

If the array cannot be expanded in size by 1 element, then the append will fail and the existing array will remain unchanged.

Parameters:

  [in] | x | the value for the x component
  [in] | y | the value for the y component
  [in] | z | the value for the z component, defaulted to 0
  [in] | w | the value for the w component, defaulted to 1

Returns:
  MS::kSuccess if the append was successful and MS::kFailure otherwise

MStatus copy | ( | const MColorArray & | source | ) |

Search for all occurrences

Copy the contents of the source array to this array.

Parameters:

  [in] | source | array to copy from

Returns:
  MS::kSuccess if the copy was successful and MS::kFailure otherwise

MStatus clear | ( |  | ) |

Search for all occurrences

Clear the contents of the array.

After this operation the length method will return 0. This does not change the amount of memory allocated to the array, only the number of valid elements in it.

Returns:
  MS::kSuccess if the operation is successful and MS::kFailure otherwise

Examples:
  meshRemapCmd.cpp.

MStatus get | ( | float | dest[][4] | ) | const

Search for all occurrences

Copy the elements of the array into the C++ array of float arrays.

No checking is done to ensure that the destination C++ array of float arrays is large enough to hold all the elements of the instance.

Parameters:

  [out] | dest | the array to populate

Returns:
  MS::kSuccess if the array argument is a non-zero pointer and MS::kFailure otherwise

void setSizeIncrement | ( | unsigned int | newIncrement | ) |

Search for all occurrences

Set the size by which the array will be expanded whenever expansion is necessary.

Parameters:

  [in] | newIncrement | the new increment

unsigned int sizeIncrement | ( |  | ) | const

Search for all occurrences

Return the size by which the array will be expanded whenever expansion is necessary.

Returns:
  The size increment.

MColor & operator[] | ( | unsigned int | index | ) |

NO SCRIPT SUPPORT.

Index operator allowing assignment to an element of the array.

Returns a reference to the element at the given index. No range checking is done - valid indices are 0 to length()-1.

Parameters:

  [in] | index | the index of the desired element

Returns:
  A reference to the indicated element

const char * className | ( |  | ) | `[static]`

Search for all occurrences

Returns the name of this class.

Returns:
  The name of this class.

## Friends And Related Function Documentation

OPENMAYA_EXPORT std::ostream& operator<< | ( | std::ostream & | os,
|  | const MColorArray & | array
| ) |  | `[friend]`

NO SCRIPT SUPPORT.

The format used is [0: [r, g, b, a], 1: [r, g, b, a], 2: [r, g, b, a], ...].

Parameters:

  [in] | os | the ostream to print to
  [in] | array | the MColorArray whose value is to be printed

Returns:
  The ostream reference, s, provided as the first parameter.

MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray
MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray MColorArray